function [B_ols, T_stat, Fore, irf_f, irfs,c_cov, RES, maxEig] = var_est_f(x , lags, c , h,t)


% OLS estimates
[T N] = size(x);
Y = reshape(x(lags+1:end,:),(T-lags)*N,1);
xx = [];
for j = 1:lags;
    xx = [xx x(lags+1-j:end-j,:) ];
end;

if c == 1
    xx = [ones(T-lags,1) xx];
end

X = kron(eye(N), xx);
B_ols = (X'*X)\X'*Y;
res = Y - X*B_ols;
RES=reshape(res,(T-lags)*N/N,N);
c_cov = RES'*RES/((T-lags)-(N*lags+c));
se = sqrt(diag((X'*X)\kron(diag(diag(c_cov)),eye(size(B_ols,1)/N))));
T_stat = B_ols./se;

% Companion matrix
AA = reshape(B_ols,size(B_ols,1)/N,N)';
A = [AA(:,c+1:end); [eye(N*(lags-1)) zeros(N*(lags-1),N)]];
 

maxEig = max(abs(eig(A)));



% temp1= zeros(size(A,1),size(A,2));
% temp2= zeros(size(A,1),size(A,2));
% for jj = 1:t
%     temp1= temp1 + (A^(jj-1)*CC).^2;
%     temp2 = kron(sum(temp1,2),ones(1,lags*N));
%     var_dec(:,:,jj)=temp1./temp2;
% end

if c~0
    CC = zeros(lags*N,1);
    for jj = 1:h
        CC = CC + A^(jj-1)*[B_ols(1:lags*N+1:end,1) ;zeros(N*(lags-1),1)];
    end
end




fo = CC + A^h*[x(end,1:N) xx(end,c+1:end-N)]';

Fore = fo(1:N,1);



% IRF
M = zeros((lags)); M(1,1)=1;
CC = kron(M,chol(c_cov)');
for i=0:t
    irf(:,:,i+1)=A^i*CC;
end

irf_f= irf(1:N,1:N,:);

for i=0:t
    irfs(1:N,1:N,i+1)=irf(1:N,1:N,i+1)*diag(diag(irf(1:N,1:N,1)))^-1;
end

% 
% % Figure
% figure(11);
% count = 0 ;
% for i = 1:N
%     for j = 1:N
%         count = count +1;
%         subplot(N,N,count); plot((1:t+1)',(-squeeze(irf(i,j,:))));;grid on ; axis([1 t+1 -inf inf])
%     end
% end
% 
% 
% % Figure
% figure(13);
% count = 0 ;
% for i = 1:N
%     for j = 1:N
%         count = count +1;
%         subplot(N,N,count); plot((1:t+1)',(-squeeze(irfs(i,j,:))));;grid on ; axis([1 t+1 -inf inf])
%     end
% end